% Program for apriori check of hmax
%
% Instructions:
%
% 1) Users have to choose a zero tolerance. Any values that are in magnitude
%    less than that value are numerically zero.
% 2) Users have to specify the objective ODE.
% 3) Users have to specify a viewing window [0,T] in time and [ymin,ymax] for
%    the observed range of values of the solution.
% 4) Program requires the function MAX, provided separately.

%
% User specifications:
%

% Set zero tolerance
zero=1e-14;
% Use symbolic engine for y
syms y
% Define objective ODE
dydt=exp(y);
% Set viewing window
ymin=0;
ymax=5;
T=5; %time interval [0,T] 

a=diff(dydt,2)/2;  
b=diff(dydt,1);
c=dydt;
delta=b^2-4*a*c;
s=b^2+abs(delta);
% The separate function MAX is using the standard matlab function 'fminbnd'
bmax=MAX(b,ymin,ymax);
smax=MAX(s,ymin,ymax);
if (smax>zero)&&(bmax>zero)
    hmax=min([2/sqrt(smax) (2-zero)/bmax T]);
elseif  (smax>zero)&&(bmax<=zero)
    hmax=min([2/sqrt(smax) T]);
else
    hmax=T;
end
hmaxOUT=['Suggest stepsize to be less than ',num2str(hmax)];
disp(hmaxOUT)





